<form name="update_form" novalidate ng-submit="updateForm()">
    <div class="modal-header">
        <h3 class="modal-title">Update a User</h3>
    </div>
    <div class="modal-body">
        <div class="form-group">
            <label for="fName">First Name:</label>
            <input type="text" id="fName"
                   placeholder="First Name"
                   class="form-control"
                   name="fName"
                   ng-model="update.fName"
                   ng-minlength=3
                   ng-maxlength=20
                   ng-class="{error: update_form.fName.$dirty && update_form.fName.$invalid}"
                   required />

            <div class="error" ng-show="update_form.fName.$dirty && update_form.fName.$invalid && !update_form.fName.$focused">
                <small class="error" ng-show="update_form.fName.$error.required">Your name is required.</small>
                <small class="error" ng-show="update_form.fName.$error.minlength">Your name is required to be at least 3 characters</small>
                <small class="error" ng-show="update_form.fName.$error.maxlength">Your name cannot be longer than 20 characters</small>
            </div>
        </div>
        <div class="form-group">
            <label for="lName">Last Name:</label>
            <input type="text" id="lName"
                   placeholder="Lst Name"
                   class="form-control"
                   name="lName"
                   ng-model="update.lName"
                   ng-minlength=3
                   ng-maxlength=20
                   ng-class="{error: update_form.lName.$dirty && update_form.lName.$invalid}"
                   required />

            <div class="error" ng-show="update_form.lName.$dirty && update_form.lName.$invalid && !update_form.lName.$focused">
                <small class="error" ng-show="update_form.lName.$error.required">Your name is required.</small>
                <small class="error" ng-show="update_form.lName.$error.minlength">Your name is required to be at least 3 characters</small>
                <small class="error" ng-show="update_form.lName.$error.maxlength">Your name cannot be longer than 20 characters</small>
            </div>
        </div>
        <div class="form-group">
            <label for="email">Email address:</label>
            <input type="email" id="email"
                   placeholder="Email address"
                   class="form-control"
                   name="email"
                   ng-model="update.email"
                   ng-class="{error: update_form.email.$dirty && update_form.email.$invalid}"
                   required />

            <div class="error" ng-show="update_form.email.$dirty && update_form.email.$invalid && !update_form.email.$focused">
                <small class="error" ng-show="update_form.email.$error.required">Your name is required.</small>
                <small class="error" ng-show="update_form.email.$error.email">That is not a valid email. Please input a valid email.</small>
            </div>
        </div>
        <div class="form-group">
            <label for="role">Role:</label>
            <select required id="role" name="role" class="form-control" ng-options="o.name for o in ::roles" ng-model="update.role"></select>
        </div>
        <div class="checkbox">
            <label><input ng-checked="update.active === 1" name="active" ng-model="update.active" type="checkbox"> Active</label>
        </div>
    </div>
    <div class="modal-footer">
        <button class="btn btn-primary" type="submit" ng-disabled="update_form.$invalid">OK</button>
        <button class="btn btn-warning" type="button" ng-click="cancel()">Cancel</button>
    </div>
</form>